package othello;

import othello.model.* ;

import java.net.InetAddress;
import java.rmi.* ;
import java.rmi.registry.*;
import java.util.Scanner;
import java.util.regex.Pattern;

/**
 * <p>Title: Othello</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Memorial University</p>
 * @author Theodore Norvell
 * @version 1.0
 */

public class ServerMain {
	public static void main( String[] args ) {
		// See http://docs.oracle.com/javase/tutorial/rmi/implementing.html

		Scanner in = new Scanner(System.in) ;
		final int port = 1491 ;
		String name = null ;
		if( args.length > 0 ) name = args[0] ;
		 
		while( name == null ) {
			final String defaultName = "gameModel" ;
			System.out.println( "Enter name for model. Default is '"+defaultName+"'" ) ;
			name = in.nextLine();
			
			if( Pattern.matches("", name)) { name = defaultName ;  }
			else if( Pattern.matches("[a-zA-Z0-9]+", name)) {  }
			else {
				name = null ;
				System.out.println( "Please stick to ASCII letters and digits." ) ; }
		}

		try {
			System.out.println("About to make game model");
			RemoteGameModel gameModel = new RemoteGameModel() ;

			// The shutDownHook is to be run at system shutdown.
			final String copyOfName = name ;
			Thread shutDownHook = new Thread() {
				@Override public void run() {
					try { 
						Naming.unbind(copyOfName) ;
						System.out.println("Model is unbound");}
					catch( Throwable e ) {} } } ;
					System.out.println("About to create registry");
					Registry registry = LocateRegistry.createRegistry(port);
					System.out.println("About to rebind");
					registry.rebind(name, gameModel);

					String ip = InetAddress.getLocalHost().getHostAddress() ;
					System.out.println("Game model bound to rmi://" +ip+ ":" +port+ "/" +name);
					Runtime.getRuntime().addShutdownHook(shutDownHook) ;
					System.out.println("Press Enter to unbind and exit.") ;
					in.nextLine() ;
		}
		catch( Throwable e ) {
			System.out.println("Exception while setting up server object") ;
			e.printStackTrace( System.err ); }
		
		in.close(); 
		System.exit(0); 
	}
}